;****************************************************************************
;****************************************************************************
;***          AT90S2333/4433 ADC  R U T I N S 
;***
;***		    MCLK=3.6864MHz !!!
;****************************************************************************
;****************************************************************************
;*
;* FUNCTION
;*	Init_ADC
;*
;* DESCRIPTION
;*	Initialize internal 10 bits ADC.
;*
;* CODE SIZE:
;*	*** words
;*
;***************************************************************************

Init_ADC:
	ldi	R16,5
	out	ADMUX,R16	;Select 5.CH, BandGap Dis.
	ldi	R16,128+8+5
	out	ADCSR,R16	;ADC en.,No Free RUN, Int. En., Div by 16
				;ADC CLK=115.2kHz  (3.6864MHz/32)
	sbi	ADCSR,ADSC	;Start Dumy A/D Conv.

	ldi	R16,238		;Wait ~560us for dumy conv
IADC1:	nop
        nop
	nop
	nop
	nop
	nop
	dec	R16
	brne	IADC1

	sbi	ADCSR,ADSC	;Start real A/D Conv.
	ret




;***************************************************************************
;*
;* FUNCTION
;*	ADC_INT
;*
;* DESCRIPTION
;*	ADC interrupt rutin
;*
;* CODE SIZE:
;*	xxx words
;*
;***************************************************************************

ADC_INT:	push	zl
		push	zh
		in	zl,SREG			; preserve main OS status reg.
		push	zl
	
		in	zl,ADMUX
		cpi	zl,5
		in	zl,ADCL
		in	zh,ADCH
		breq	ADCline

ADCcurrent:	
;		lsr	zh
;		ror	zl	
		std	Y+ADC_CH4+0-RAMSTRT,zl
		std	Y+ADC_CH4+1-RAMSTRT,zh
		ldi	zl,5			;kovetkezo a line lesz
		out	ADMUX,zl
		rjmp	ADCEnd	
	

ADCline:
;		lsr	zh
;		ror	zl
		std	Y+ADC_CH5+0-RAMSTRT,zl
		std	Y+ADC_CH5+1-RAMSTRT,zh
		ldi	zl,4			;kovetkezo a current lesz
		out	ADMUX,zl

ADCEnd:		ldi	zl,10
ADCW:		dec	zl			;Wait for mux????
		brne	ADCW


		pop	zl
		out	SREG,zl			; restore previous status reg
		pop	zh
		pop	zl
		sbi	ADCSR,ADSC		;Start A/D Conv.
		reti




