; ** FAST unsigned 16bit multiplier Routines for Atmel AVR RISC **
;**  Unsigned 16bit Mul  **
;** [Acc1 = Acc1 * Acc2] **

UMUL16:	clr	uutemp		; Test for Acc1 == 0	
	or	uutemp,uumant1l
	or	uutemp,uumant1h
	breq	UMULX		; if Acc1 == 0, return

	clr	uutemp		; Test for Acc2 == 0
	or	uutemp,uumant2l
	or	uutemp,uumant2h
	brne	UMULOK
	clr 	uumant1l		; yes, x * 0 = 0. 
	clr 	uumant1h
	ret
UMULOK:	clr	uuprodl
	clr 	uuprodh
	clr 	uutemp		; used for 'adci mant1x,0'
	ldi 	uucount,16	; number of bits to proc.
UMULLP:	lsl	uuprodl
	rol 	uuprodh
	rol 	uumant1l
	rol 	uumant1h
	brcc	UMUL1
	add 	uuprodl,uumant2l
	adc 	uuprodh,uumant2h
	adc 	uumant1l,uutemp	; addi 0+Carry
	adc 	uumant1h,uutemp	; trickle the Carry on down.
UMUL1:	dec	uucount
	brne	UMULLP
	mov 	uumant1h,uuprodh
	mov 	uumant1l,uuprodl
UMULX:	ret
